#!/bin/bash
#
# shrink an mpg to MPEG-4 (xvid)
#
#----------------------------------------------------

# a negative bitrate specifies a a file size in k and tells 
# mencoder to calculate bitrate for you
#
# 
getBitrate() {
    local bitrate
    local k
    local gb

    if [ "$1" = 'lo' ]
    then
        bitrate=$lo_quality_bitrate
        echo $bitrate
        return 0
    fi

    if [ "$1" = 'hi' ]
    then
        bitrate=$hi_quality_bitrate
        echo $bitrate
        return 0
    fi

    if [ "`echo $1 | grep mb$`" ]
    then
        bitrate='-'"`echo $1 | sed 's/mb//'`"'000'
        echo $bitrate
        return 0
    fi

    
    if [ "`echo $1 | grep gb$`" ]
    then
        gb="`echo $1 | sed 's/gb//'`"
        k=`echo "gb * 1000000" | bc`
        bitrate='-'"`echo $k | sed 's/[.][0-9]*$//'`"
        echo $bitrate
        return 0
    fi
    
    return 1
}
#
# $1 - name of mpg file
#
getTitle() {
    echo `basename $1 | sed s/[.][a-zA-Z0-9]*$//`
    return 0
}

encodeAsh264() 
{
    src="$1"
    dest="$2"
    bitrate="$3"
    
    echo '--------------------PASS 1--------------------------------'
    mencoder $src -ovc x264 -oac copy -x264encopts bitrate=${bitrate}:pass=1:subq=1:partitions=all:8x8dct:me=umh:frameref=1:bframes=3:b_pyramid:weight_b:threads=auto:qcomp=0.8 -o /dev/null 
    echo '--------------------PASS 2--------------------------------'
    mencoder $src -ovc x264 -oac copy -x264encopts bitrate=${bitrate}:pass=2:subq=7:partitions=all:8x8dct:me=umh:frameref=8:bframes=4:b_pyramid:weight_b:threads=auto:qcomp=0.8 -o $dest
    echo '----------------------------------------------------------'
}
encodeAsxvid() 
{
    src="$1"
    dest="$2"
    bitrate="$3"

    echo '--------------------PASS 1--------------------------------'
    mencoder $src -ovc xvid -oac copy -xvidencopts pass=1 -o /dev/null 
    echo '--------------------PASS 2--------------------------------'
    mencoder $src -ovc xvid -oac copy -xvidencopts pass=2:bitrate=$bitrate -o $dest
    echo '----------------------------------------------------------'
}

#----------------------------------------------------

source $config


if [ ! "$1" ] || [ ! "$2" ]
then    
    showHelp 'mp4'
    exit 1
fi

if [ ! -f "$2" ]
then
    
    exit 1
fi

bitrate=`getBitrate "$1"`
dest=`getTitle "$2"`.mp4
encodeAsh264 "$2" "$dest" "$bitrate" 

#echo $config
#echo $lo_quality_bitrate
#echo $hi_quality_bitrate
#echo $2
#echo $bitrate
#echo $dest
#exit 0


rm divx2pass.log
echo "command: encode [$2] @ bitrate [$bitrate] to [$dest]"
exit 0

